Module javafx.base
Package javafx.beans.property

# Class DoubleProperty

java.lang.Object
javafx.beans.binding.NumberExpressionBase
javafx.beans.binding.DoubleExpression
javafx.beans.property.ReadOnlyDoubleProperty
javafx.beans.property.DoubleProperty

All Implemented Interfaces:
  `NumberExpression`, `Observable`, `Property<Number>`, `ReadOnlyProperty<Number>`, `ObservableDoubleValue`, `ObservableNumberValue`, `ObservableValue<Number>`, `WritableDoubleValue`, `WritableNumberValue`, `WritableValue<Number>`

Direct Known Subclasses:
  `DoublePropertyBase`, `JavaBeanDoubleProperty`

public abstract class DoubleProperty extends ReadOnlyDoubleProperty implements Property<Number>, WritableDoubleValue
This class defines a `Property` wrapping a `double` value.

The value of a `DoubleProperty` can be get and set with `ObservableDoubleValue.get()`, `DoubleExpression.getValue()`, `WritableDoubleValue.set(double)`, and `setValue(Number)`.

A property can be bound and unbound unidirectional with `Property.bind(ObservableValue)` and `Property.unbind()`. Bidirectional bindings can be created and removed with `bindBidirectional(Property)` and `unbindBidirectional(Property)`.

The context of a `DoubleProperty` can be read with `ReadOnlyProperty.getBean()` and `ReadOnlyProperty.getName()`.

Note: setting or binding this property to a null value will set the property to "0.0". See `setValue(java.lang.Number)`.

Since:
  JavaFX 2.0
See Also:
  - `ObservableDoubleValue`
  - `WritableDoubleValue`
  - `ReadOnlyDoubleProperty`
  - `Property`

## Constructor Summary

Constructors
Constructor
Description
`DoubleProperty()`

## Method Summary

Modifier and Type
Method
Description
`ObjectProperty<Double>`
`asObject()`
Creates an `ObjectProperty` that bidirectionally bound to this `DoubleProperty`.
`void`
`bindBidirectional(Property<Number> other)`
Create a bidirectional binding between this `Property` and another one.
`static DoubleProperty`
`doubleProperty(Property<Double> property)`
Returns a `DoubleProperty` that wraps a `Property` and is bidirectionally bound to it.
`void`
`setValue(Number v)`
Set the wrapped value.
`String`
`toString()`
Returns a string representation of this `DoubleProperty` object.
`void`
`unbindBidirectional(Property<Number> other)`
Remove a bidirectional binding between this `Property` and another one.

### Methods inherited from class javafx.beans.property.ReadOnlyDoubleProperty

`readOnlyDoubleProperty`

### Methods inherited from class javafx.beans.binding.DoubleExpression

`add, add, add, add, add, divide, divide, divide, divide, divide, doubleExpression, doubleExpression, doubleValue, floatValue, getValue, intValue, longValue, multiply, multiply, multiply, multiply, multiply, negate, subtract, subtract, subtract, subtract, subtract`

### Methods inherited from class javafx.beans.binding.NumberExpressionBase

`asString, asString, asString, greaterThan, greaterThan, greaterThan, greaterThan, greaterThan, greaterThanOrEqualTo, greaterThanOrEqualTo, greaterThanOrEqualTo, greaterThanOrEqualTo, greaterThanOrEqualTo, isEqualTo, isEqualTo, isEqualTo, isEqualTo, isEqualTo, isEqualTo, isEqualTo, isEqualTo, isNotEqualTo, isNotEqualTo, isNotEqualTo, isNotEqualTo, isNotEqualTo, isNotEqualTo, isNotEqualTo, isNotEqualTo, lessThan, lessThan, lessThan, lessThan, lessThan, lessThanOrEqualTo, lessThanOrEqualTo, lessThanOrEqualTo, lessThanOrEqualTo, lessThanOrEqualTo, numberExpression`

### Methods inherited from class java.lang.Object

`clone, equals, finalize, getClass, hashCode, notify, notifyAll, wait, wait, wait`

### Methods inherited from interface javafx.beans.Observable

`addListener, removeListener`

### Methods inherited from interface javafx.beans.value.ObservableDoubleValue

`get`

### Methods inherited from interface javafx.beans.value.ObservableValue

`addListener, getValue, removeListener`

### Methods inherited from interface javafx.beans.property.Property

`bind, isBound, unbind`

### Methods inherited from interface javafx.beans.property.ReadOnlyProperty

`getBean, getName`

### Methods inherited from interface javafx.beans.value.WritableDoubleValue

`get, set`

### Methods inherited from interface javafx.beans.value.WritableValue

`getValue`

## Constructor Details

### DoubleProperty

public DoubleProperty()

## Method Details

### setValue

public void setValue(Number v)
Set the wrapped value.

Specified by:
  `setValue` in interface `WritableDoubleValue`
Specified by:
  `setValue` in interface `WritableValue<Number>`
Parameters:
  `v` - The new value

### bindBidirectional

public void bindBidirectional(Property<Number> other)
Create a bidirectional binding between this `Property` and another one. Bidirectional bindings exists independently of unidirectional bindings. So it is possible to add unidirectional binding to a property with bidirectional binding and vice-versa. However, this practice is discouraged.

It is possible to have multiple bidirectional bindings of one Property.

JavaFX bidirectional binding implementation use weak listeners. This means bidirectional binding does not prevent properties from being garbage collected.

Specified by:
  `bindBidirectional` in interface `Property<Number>`
Parameters:
  `other` - the other `Property`

### unbindBidirectional

public void unbindBidirectional(Property<Number> other)
Remove a bidirectional binding between this `Property` and another one. If no bidirectional binding between the properties exists, calling this method has no effect. It is possible to unbind by a call on the second property. This code will work:

>          property1.bindBirectional(property2);
>          property2.unbindBidirectional(property1);

Specified by:
  `unbindBidirectional` in interface `Property<Number>`
Parameters:
  `other` - the other `Property`

### toString

public String toString()
Returns a string representation of this `DoubleProperty` object.

Overrides:
  `toString` in class `ReadOnlyDoubleProperty`
Returns:
  a string representation of this `DoubleProperty` object.

### doubleProperty

public static DoubleProperty doubleProperty(Property<Double> property)
Returns a `DoubleProperty` that wraps a `Property` and is bidirectionally bound to it. Changing this property will result in a change of the original property.

This is very useful when bidirectionally binding an ObjectProperty<Double> and a DoubleProperty.

>        DoubleProperty doubleProperty = new SimpleDoubleProperty(1.0);
>        ObjectProperty<Double> objectProperty = new SimpleObjectProperty<>(2.0);

>        // Need to keep the reference as bidirectional binding uses weak references
>        DoubleProperty objectAsDouble = DoubleProperty.doubleProperty(objectProperty);

>        doubleProperty.bindBidirectional(objectAsDouble);

Another approach is to convert the DoubleProperty to ObjectProperty using `asObject()` method.

Note: null values in the source property will be interpreted as 0.0

Parameters:
  `property` - The source `Property`
Returns:
  A `DoubleProperty` that wraps the `Property`
Throws:
  `NullPointerException` - if `property` is `null`
Since:
  JavaFX 8.0
See Also:
  - `asObject()`

### asObject

public ObjectProperty<Double> asObject()
Creates an `ObjectProperty` that bidirectionally bound to this `DoubleProperty`. If the value of this `DoubleProperty` changes, the value of the `ObjectProperty` will be updated automatically and vice-versa.

Can be used for binding an ObjectProperty to DoubleProperty.

>        DoubleProperty doubleProperty = new SimpleDoubleProperty(1.0);
>        ObjectProperty<Double> objectProperty = new SimpleObjectProperty<>(2.0);

>        objectProperty.bind(doubleProperty.asObject());

Overrides:
  `asObject` in class `ReadOnlyDoubleProperty`
Returns:
  the new `ObjectProperty`
Since:
  JavaFX 8.0